/* Copyright(c) 2002,2003 Device Drivers Limited, All rights reserved. */
/*                              info@devdrv.com http://www.devdrv.com/ */
#include <stdio.h>
#include <pthread.h>
#include <fcntl.h>
#include <termio.h>

int fdr;
int fdw;
char rbuf[256]; /* ¦Хåե */
char wbuf[256] = "abcdefghij"; /* ߡǡƤǧ뤿 */

#define LOOP_COUNT 20 /* 롼ץ,115200bpsߤ뤿ɬ */

/* 񤭹¦å */
void *threadA (char *arg)
{
  int i, len;

  printf("Thread-A Start.\n");
  for(i = 0; i < LOOP_COUNT; i++) {
    len = write(fdw, wbuf, 256); /* 256ХȡߣΥǡ */
  }
  close(fdw);
}

/* ɤ߹¦å */
void *threadB (char *arg)
{
  int i, len, total;

  total = 0;
  printf("Thread-B Start.\n");
  for(i = 0;; i++) {       /* ΩޤǤ̵¥롼 */
    len = read(fdr, rbuf, 256); /* ºݤϥХȿlen¸ */
    if(i == 1) {           /* 󥿤ΤȤʣܤΥ롼פǡ*/
      tcflow(fdr, TCOOFF); /* RTSOFFˤ̿׵᤹ */
      sleep(1);            /* ôԤ */
      tcflow(fdr, TCOON);  /* RTSONˤ̿Ƴ */
    }
    printf("%d(%d): %s\n", i, len, rbuf); /* ưǧΤвɽ */
    if ((total+=len) >= (LOOP_COUNT * 256)) /* ϥХȿ׻ */
      break;               /* ϤХȤȰפнλ */
  }
  close(fdr);
}

int main()
{
  int s;
  struct termios tio;
  pthread_t thA, thB;

  /* ɤ߹¦ǥץΥץ */
  if ((fdr = open("/dev/ttyS0", O_RDONLY)) < 0) {
    fprintf(stderr, "th: open error\n");
    exit(1);
  }
  /* 񤭹߹¦ǥץΥץ */
  if ((fdw = open("/dev/ttyS0", O_WRONLY)) < 0) {
    fprintf(stderr, "th: open error\n");
    exit(1);
  }
  printf("Program Start.\n");
  bzero(&tio, sizeof(tio)); /* ȥӥ塼깽¤Τν */

  /* 115200bps, եͭ, ӥåȡDTR/DSR̵ǽ */
  tio.c_cflag = B115200 | CRTSCTS | CS8 | CLOCAL | CREAD;
  tio.c_cc[VMIN] = 1; /* ϥǡХåեʤ */
  tcsetattr(fdr, TCSANOW, &tio);  /* ¦ȥӥ塼ȤΥå */
  tcsetattr(fdw, TCSANOW, &tio);  /* ¦ȥӥ塼ȤΥå */

  if ((s = pthread_create(&thB, NULL, (void*) threadB, NULL)) != 0) {
    printf("thB: create error!\n"); /* ɤ߹¦åɤεưȥ顼 */
    exit(2);
  }
  if ((s = pthread_create(&thA, NULL, (void*) threadA, NULL)) != 0) {
    printf("thA: create error!\n"); /* 񤭹¦åɤεưȥ顼 */
    exit(3);
  }

  if ((s = pthread_join(thA, NULL)) != 0) { /* åɤνλԤ */
    printf("thA: join error!\n");
    exit(4);
  }
  printf("Thread-A Exit.\n");
  if ((s = pthread_join(thB, NULL)) != 0) { /* åɤνλԤ */
    printf("thB: join error!\n");
    exit(5);
  }
  printf("Thread-B Exit.\n");
  exit(0);
}

/*
ѥ륳ޥɡ
cc -g -lpthread -o thread-io thread-io.c
*/
